#ifndef DIZ_H
#define DIZ_H

/////////////////////////////////////////////////////////////////////////////
// codici di errore
/////////////////////////////////////////////////////////////////////////////
#define RESULT_OK			0	// la funzione ha avuto successo
#define UNKNOWN_ERROR		1	// errore sconosciuto
#define NULL_POINTER		2	// uno degli argomenti della funzione era NULL
#define EMPTY_STRING		3	// uno degli argomenti era una stringa vuota
#define FILE_MISSING		4	// il file non esiste
#define FILE_UNREADABLE		5	// il file non  leggibile
#define FILE_UNWRITABLE		6	// il file non  scrivibile
#define FILE_EMPTY	     	7	// il file  vuoto
#define BUFFER_TOO_SMALL	8	// il blocco di memoria (o vettore) passato non  sufficiente a contenere i dati
#define HEADER_NOT_FOUND	9	// lo header del messaggio non esiste
#define BODY_NOT_FOUND		10	// il corpo del messaggio non esiste
#define BAD_HEADER		    11	// una riga degli headers non segue la sintassi giusta
#define MEM_ALLOC_ERROR		12	// non si  potuto allocare un blocco di memoria
#define LAST_CODE			13	// (da non usare) numero di codici di errore definiti
#define INVALID_PARAMETER	14	// ad esempio una dimensione negativa
#define MATCH_NOT_FOUND		15  // non si  trovato alcun match nel testo
#define RE_PAIR_NOT_FOUND	16	// il testo non contiene nessuna coppia match-replace (oltre ai commenti)
#define BAD_RE_PAIR		    17	// il testo non contiene un numero pari di coppie di righe (oltre ai commenti)
#define BAD_MATCH		    18	// la stringa match d errore (chiamando libprce)
#define BAD_REPLACE		    19	// la stringa rimpiazzata d errore (chiamando libprce)
#define DOUBLE_KEY_FOUND    20
#define TABLE_FULL          21
#define KEY_NOT_FOUND       22


struct Dizionario /* handler per l'intera struttura dizionario */
{
    struct DizNodo * index[26]; /* indice */
};

struct DizNodo /* singolo nodo del dizionario */
{
    char *key;  /* chiave di ricerca */
    char *value;   /* valore associato */
    struct DizNodo * next;
};

typedef struct Dizionario* hash;

/////////////////////////////////////////////////////////////////////////////
// prototipi delle funzioni
/////////////////////////////////////////////////////////////////////////////

// creo un nuovo dizionario (o hash-table di dimensioni massime fissate)
struct Dizionario * nuovoDizionario( void );

// disalloco il dizionario (o hash-table)
int freeDizionario(struct Dizionario * dizionario);

// inserisco un nuovo valore in corrispondenza della chiave
int inserisciValore(char * chiave, char * valore, struct Dizionario * diz);

// cerco un valore nel dizionario (o hashtable), data la chiave
int cercaValore(char * chiave, struct Dizionario * diz, char ** valore);

#endif
