#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include "mredir.h"

int modify_std_streams( const int new_stdin, const int new_stdout, const int new_stderr,
                        int *old_stdin, int *old_stdout, int *old_stderr )
{

    if ( new_stdin > 0 )
    {
        if ( old_stdin )
            *old_stdin = dup( STDIN_FILENO ); // create a copy of old stdin

        dup2( new_stdin, STDIN_FILENO ); // redirect stdin
        close( new_stdin ); //correct?
    }

    if ( new_stdout > 0 )
    {
        if ( old_stdout )
            *old_stdout = dup( STDOUT_FILENO ); // create a copy of old stdout

        dup2( new_stdout, STDOUT_FILENO ); // redirect stdout
        close( new_stdout ); //correct?
    }

    if ( new_stderr > 0 )
    {
        if ( old_stderr )
            *old_stderr = dup( STDERR_FILENO ); // create a copy of old stderr

        dup2( new_stderr, STDERR_FILENO ); // redirect stderr
        close( new_stderr ); //correct?
    }

    return 0;
}

int restore_std_streams( const int old_stdin, const int old_stdout, const int old_stderr )
{ //TODO: check for errors?
    if ( old_stdin > 0 )
    {
        fflush( stdin );
        close( stdin ); //correct?
        dup2( old_stdin, STDIN_FILENO ); // reassign old file descriptor to stdin
        close( old_stdin );
    }

    if ( old_stdout > 0 )
    {
        fflush( stdout );
        close( stdout ); //correct?
        dup2( old_stdout, STDOUT_FILENO ); // reassign old file descriptor to stdout
        close( old_stdout );
    }

    if ( old_stderr > 0 )
    {
        fflush( stderr );
        close( stderr ); //correct?
        dup2( old_stderr, STDERR_FILENO); // reassign old file descriptor to stderr
        close( old_stderr );
    }

    return 0;
}
