// ush - some non-POSIX string manipulation functions, provided for portability

#ifndef MSTRING_H
#define MSTRING_H

/* Very simple itoa implementation using sprintf
   suggestion taken fron Wikipedia (http://en.wikipedia.org/wiki/Itoa) */
char *itoa(int i);

// Returns a pointer to the last occurrence of a substring within another string
// Written by Kent Irwin, irwin@leland.stanford.edu
char *strrstr( char *s1, char *s2 );

// macro that checks if a char c in a string s is quoted ( surrounded by quotes )
#define isquoted( c, s ) \
( (strchr(s, '\'') < c && strchr(c, '\'')) || \
  (strchr(s, '\"') < c && strchr(c, '\"')) )

/* Compares a given string with an array of strings
   and returns 1=true if at least 1 string match (case-sensitive comparison) */
int stracmp( char *s, char **a );

/* Converts a string in UPPERCASE
   NOTE: s MUST NOT be declared as a static string! */
void strupcase( char *s );

/* Find the first occurrence of b in a ignoring cases
  */
// char *strcasestr(char *a, char *b);

/* Replaces substring within a string.
   returns NULL if no substring to replace.
   coded by ibanja (http://www.experts-exchange.com/Programming/Programming_Languages/C/Q_21822619.html) */
char *strrep(char *string, char *strToRep, char *strReplacement);

// Replaces a group of strings in an array with a given one
//?? void astrrep(char **strarr, unsigned int start_str, unsigned int end_str, char *strreplacement);

#endif
