#include "queue.h"

queue createqueue( void )
{
    struct queuehandler * p;
    p=(struct queuehandler*) malloc(sizeof(struct queuehandler));
    if(!p)
    {
        fputs("Insufficient memory\n", stderr);
        return NULL;
    }
    p->head=NULL;
    p->tail=NULL;
    p->size=0;
    return p;
}

void enqueue(queue q, queue_type data)
{
    if(!q) return;
    struct queuenode * p;
    p=(struct queuenode*) malloc(sizeof(struct queuenode));
    if(!p)
    {
        fputs("Insufficient memory\n", stderr);
        return;
    }
    p->data=data;
    p->next=NULL;
    if(q->size == 0)
    {
        q->head=p;
        q->tail=p;
    }
    else
    {
        q->tail->next=p;
        q->tail=p;
    }
    q->size++;
    return;
}

queue_type dequeue(queue q)
{
    if(!q) return (queue_type)(-1);
    struct queuenode * p;
    queue_type r;

    r=q->head->data;
    p=q->head;
    q->head=q->head->next;
    free(p);
    q->size--;
    return r;
}

void printqueue(queue q)
{
    struct queuenode * p;
    p=q->head;
    while(p)
    {
        printf(" %d -->", p->data);
        p=p->next;
    }
    puts(" END");
    return;
}

void freequeue(queue q)
{
    if(!q) return;
    struct queuenode * p;
    struct queuenode * r;
    p=q->head;
    while(p)
    {
        r=p->next;
        free(p);
        p=r;
    }
    free(q);
    return;
}

int isempty(queue q)
{
    if(!q) return 1;
    else return(!q->size);
}

/*
int main()
{
    queue test=createqueue();
    enqueue(test, (cmdPtr)0); dequeue(test);
    enqueue(test, (cmdPtr)1);
    enqueue(test, (cmdPtr)2);
    enqueue(test, (cmdPtr)3);
    enqueue(test, (cmdPtr)4);

    while(!isempty(test))
    {
        printf("%d\n", (int)dequeue(test));
    }
    return 1;
}
*/
