#include "ush.h"
#include "ush-var.h"
#include "mstring.h"
#include "diz.h"

const char *empty="";

extern hash aliases;

char *read_variable( char *name )
{
    if ( !name || !*name )
        return empty;

    char *value = getenv(name);

    if ( !value )
        return empty;
    else
        return value;
}

int write_variable( char *name, char *value ) // TODO: rifare manipolando direttamente extern char **environ x migliore portabilit?
{
    if ( !name || !*name )
        return -1;

    if( !value ) value = empty; // empty value is accepted for a variable

    // if variable already exists, frees it before overwrite
    /*
    if ( getenv(name) )
        free( getenv(name) );
    */

    char *declaration = calloc( sizeof(char), strlen(name)+strlen(value)+2 );
    sprintf(declaration, "%s=%s", name, value);
    int rv = putenv(declaration);
        //alternative: int rv = setenv( strdup(name), strdup(value), 1 );

    // free(declaration); -> NO! It cancels the declaration itself!
    return rv;
}

char *read_alias( char *name )
{
    char *r;
    if ( cercaValore( name, aliases, &r ) == 0 )
        return r;
    else
        return NULL;
}

int write_alias( char *name, char *value )
{
    return inserisciValore( name, value, aliases );
}
