#include "ush.h"
#include "queue.h"
#include "diz.h"
#include "ush-var.h"
#include "mbool.h"
#include "history.h"
#include "ush.h"
#include "ush-init.h"
#include "ush-args.h"
#include "ush-parse.h"
#include "ush-exec.h"

// global variables
char *command;
queue parsed_commands;
history hi;
bool script_mode = 0;
hash aliases;

// private module function prototypes
static void show_prompt ( void );
static void read_user_input ( void );


// main function definition
int main ( int argc, char *argv[] )
{
    initialize_ush();
    check_args( argc, argv );

    while( 1 )
    {
        show_prompt();
        read_user_input(); //TODO: rifare con GNU readline?
        historize( command, hi ); //TODO: rifare con GNU readline?
        parse_user_input( command, -1, 0 );
        execute_parsed_commands();
    }

}


// private module function definitions

static void show_prompt ( void )
{
    //TODO: implement prompt customization via PS1 and PS2 variables (needs pre-parsing)...

    if(!script_mode)
        printf("%s $ ", getcwd(NULL, 0));

    return;
}

static void read_user_input( void )
{
    if ( fgets(command, atoi(read_variable("MAX_CMD_LENGHT")), stdin) )
    {
        *( command+(strlen(command)-1)*sizeof(char) ) = '\0'; // cuts off ending newline
    }
    else if ( feof(stdin) )
    {
        // user pressed Ctrl-D or EOF in script
        exit(0);
    }

    return;
}


// public module function definitions

cmdPtr create_and_init_parsed_command( void )
{
    cmdPtr t = malloc ( sizeof( struct parsed_command ) );

    t->arguments = NULL;
    t->standard_input = -1;
    t->standard_output = -1;
    t->standard_error = -1;
    t->background = 0;

    return t;

}

void free_parsed_command( cmdPtr t )
{
    if( t->arguments )
    {
        int i = 0;
        while( t->arguments[i] )
        {
            free( t->arguments[i] );
            i++;
        }
        free( t->arguments );
    }
    free( t );
}
