// ush - common includes and datatypes declarations

#ifndef USH_H
#define USH_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/types.h>
#include <errno.h>
extern int errno;

#include "mbool.h"

// enables print of debug messages
#define USH_DEBUG 0

// some internal defaults (must be strings)
#define MAX_CMD_LENGHT_DEFAULT "1000"
#define HISTORY_SIZE_DEFAULT "30"
#define MAX_VARIABLE_NAME_LENGHT_DEFAULT "20"

// struct containing a parsed command
struct parsed_command
{
    char **arguments; /* an array of strings which will contain tokenized arguments */
    int standard_input; /* file descriptor from wich program will read standard input (-1 means default) */
    int standard_output; /* file descriptor to wich program will write standard output (-1 means default) */
    int standard_error; /* file descriptor to wich program will write standard error (-1 means default) */
    bool background; /* if is true shell will not wait for program termination */
};

typedef struct parsed_command * cmdPtr;

cmdPtr create_and_init_parsed_command( void );
void free_parsed_command( cmdPtr t );

#endif
